"""Init.

Revision ID: 1e6c72f6b4da
Revises: 
Create Date: 2022-11-28 13:14:54.349663

"""
from alembic import op
import sqlalchemy as sa
import sqlalchemy_utils
import ryax.runner.infrastructure.database.metadata


# revision identifiers, used by Alembic.
revision = '1e6c72f6b4da'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('action_definition',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=False),
    sa.Column('version', sa.String(), nullable=False),
    sa.Column('kind', sa.Enum('SOURCE', 'PROCESSOR', 'PUBLISHER', name='action_kind_enum'), nullable=False),
    sa.Column('container_image', sa.String(), nullable=False),
    sa.Column('human_name', sa.String(), nullable=False),
    sa.Column('description', sa.String(), nullable=False),
    sa.Column('has_dynamic_outputs', sa.Boolean(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('stored_file',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('io_name', sa.String(), nullable=False),
    sa.Column('file_path', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('mimetype', sa.String(), nullable=True),
    sa.Column('encoding', sa.String(), nullable=True),
    sa.Column('size_in_bytes', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_deployment',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('creation_time', sa.String(), nullable=False),
    sa.Column('workflow_definition_id', sa.String(), nullable=True),
    sa.Column('state', sa.Enum('NONE', 'CREATED', 'STARTED', 'RUNNING', 'STOPPED_GRACEFULLY', 'STOPPED', 'PAUSED', name='workflow_deployment_state_type'), nullable=False),
    sa.Column('stopped_time', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_deployment',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('action_definition_id', sa.String(), nullable=True),
    sa.Column('state', sa.Enum('CREATED', 'DEPLOYING', 'READY', 'RUNNING', 'UNDEPLOYING', 'UNDEPLOYED', 'ERROR', 'NONE', name='action_deployment_state'), nullable=False),
    sa.Column('action_internal_endpoint', sa.String(), nullable=True),
    sa.Column('user_web_access_endpoint', sa.String(), nullable=True),
    sa.Column('execution_type', sa.Enum('NONE', 'GRPC_V1', 'SLURM_SSH_V1', 'DUMMY', name='action_execution_type'), nullable=True),
    sa.Column('allocated_connection_id', sa.String(), nullable=True),
    sa.Column('last_logs_cache', sa.Text(), nullable=True),
    sa.Column('error_message', sa.String(), nullable=True),
    sa.Column('last_allocation_date', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=False),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.ForeignKeyConstraint(['action_definition_id'], ['action_definition.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_input_types',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('action_definition_id', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('NONE', 'BYTES', 'STRING', 'INTEGER', 'FLOAT', 'BOOLEAN', 'FILE', 'DIRECTORY', 'FILE_REFERENCE', 'DIRECTORY_REFERENCE', 'LONGSTRING', 'PASSWORD', 'ENUM', 'TABLE', name='action_io_type'), nullable=False),
    sa.Column('display_name', sa.String(), nullable=False),
    sa.Column('help', sa.String(), nullable=False),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=False),
    sa.ForeignKeyConstraint(['action_definition_id'], ['action_definition.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_output_types',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('action_definition_id', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('NONE', 'BYTES', 'STRING', 'INTEGER', 'FLOAT', 'BOOLEAN', 'FILE', 'DIRECTORY', 'FILE_REFERENCE', 'DIRECTORY_REFERENCE', 'LONGSTRING', 'PASSWORD', 'ENUM', 'TABLE', name='action_io_type'), nullable=False),
    sa.Column('display_name', sa.String(), nullable=False),
    sa.Column('help', sa.String(), nullable=False),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=False),
    sa.ForeignKeyConstraint(['action_definition_id'], ['action_definition.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('id_in_studio', sa.String(), nullable=False),
    sa.Column('display_name', sa.String(), nullable=True),
    sa.Column('action_definition_id', sa.String(), nullable=False),
    sa.Column('workflow_definition_id', sa.String(), nullable=True),
    sa.Column('connection_execution_id', sa.String(), nullable=True),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.Column('is_root_action', sa.Boolean(), nullable=True),
    sa.Column('position', sa.Integer(), nullable=True),
    sa.Column('workflow_deployment_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['action_definition_id'], ['action_definition.id'], ),
    sa.ForeignKeyConstraint(['workflow_deployment_id'], ['workflow_deployment.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_result',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('workflow_action_io_id', sa.String(), nullable=False),
    sa.Column('workflow_deployment_id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=False),
    sa.Column('action_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['workflow_deployment_id'], ['workflow_deployment.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('execution_result',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('workflow_run_id', sa.String(), nullable=True),
    sa.Column('execution_connection_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=True),
    sa.Column('error_message', sa.String(), nullable=True),
    sa.Column('state', sa.Enum('NONE', 'CANCELED', 'SUCCESS', 'ERROR', name='execution_result_state'), nullable=False),
    sa.Column('submitted_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('started_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('ended_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('outputs', sa.JSON(), nullable=True),
    sa.Column('inputs', sa.JSON(), nullable=True),
    sa.Column('log', sa.Text(), nullable=False),
    sa.Column('end_of_log_delimiter', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_association',
    sa.Column('parents', sa.String(), nullable=True),
    sa.Column('children', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['children'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['parents'], ['workflow_action.id'], ondelete='CASCADE')
    )
    op.create_table('workflow_action_dynamic_outputs',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('NONE', 'BYTES', 'STRING', 'INTEGER', 'FLOAT', 'BOOLEAN', 'FILE', 'DIRECTORY', 'FILE_REFERENCE', 'DIRECTORY_REFERENCE', 'LONGSTRING', 'PASSWORD', 'ENUM', 'TABLE', name='action_io_type'), nullable=False),
    sa.Column('display_name', sa.String(), nullable=False),
    sa.Column('help', sa.String(), nullable=False),
    sa.Column('enum_values', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=False),
    sa.Column('origin', sa.Enum('NONE', 'PATH', 'HEADER', 'QUERY', 'COOKIE', 'BODY', name='dynamic_output_origin'), nullable=False),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('workflow_action_reference_inputs',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('action_name', sa.String(), nullable=True),
    sa.Column('output_name', sa.String(), nullable=True),
    sa.Column('parent_action_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['parent_action_id'], ['workflow_action.id'], ),
    sa.PrimaryKeyConstraint('id', 'parent_action_id')
    )
    op.create_table('workflow_action_static_inputs',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('value', sa.PickleType(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('execution_connection',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=False),
    sa.Column('action_deployment_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=True),
    sa.Column('inputs', sa.JSON(), nullable=True),
    sa.Column('workflow_run_id', sa.String(), nullable=True),
    sa.Column('state', sa.Enum('NONE', 'CREATED', 'PENDING', 'ALLOCATED', 'RUNNING', 'COMPLETED', 'CANCELED', 'ERROR', name='execution_connection_state'), nullable=False),
    sa.Column('error_message', sa.String(), nullable=False),
    sa.Column('executor_id', sa.String(), nullable=True),
    sa.Column('submitted_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('started_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('ended_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('parent_execution_result_id', sa.String(), nullable=True),
    sa.Column('end_of_log_delimiter_queue', sqlalchemy_utils.types.scalar_list.ScalarListType(), nullable=True),
    sa.ForeignKeyConstraint(['action_deployment_id'], ['action_deployment.id'], ),
    sa.ForeignKeyConstraint(['parent_execution_result_id'], ['execution_result.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('execution_result_association',
    sa.Column('parents', sa.String(), nullable=True),
    sa.Column('children', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['children'], ['execution_result.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['parents'], ['execution_result.id'], ondelete='CASCADE')
    )
    op.create_table('stored_file_association',
    sa.Column('stored_file_id', sa.String(), nullable=True),
    sa.Column('execution_result_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['execution_result_id'], ['execution_result.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['stored_file_id'], ['stored_file.id'], ondelete='CASCADE')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('stored_file_association')
    op.drop_table('execution_result_association')
    op.drop_table('execution_connection')
    op.drop_table('workflow_action_static_inputs')
    op.drop_table('workflow_action_reference_inputs')
    op.drop_table('workflow_action_dynamic_outputs')
    op.drop_table('workflow_action_association')
    op.drop_table('execution_result')
    op.drop_table('workflow_result')
    op.drop_table('workflow_action')
    op.drop_table('action_output_types')
    op.drop_table('action_input_types')
    op.drop_table('action_deployment')
    op.drop_table('workflow_deployment')
    op.drop_table('stored_file')
    op.drop_table('action_definition')
    # ### end Alembic commands ###
